﻿/*
DotNetNote의 배포 스크립트

이 코드는 도구를 사용하여 생성되었습니다.
파일 내용을 변경하면 잘못된 동작이 발생할 수 있으며, 코드를 다시 생성하면
변경 내용이 손실됩니다.
*/

GO
SET ANSI_NULLS, ANSI_PADDING, ANSI_WARNINGS, ARITHABORT, CONCAT_NULL_YIELDS_NULL, QUOTED_IDENTIFIER ON;

SET NUMERIC_ROUNDABORT OFF;


GO
:setvar DatabaseName "DotNetNote"
:setvar DefaultFilePrefix "DotNetNote"
:setvar DefaultDataPath "C:\Users\VisualAcademy\AppData\Local\Microsoft\Microsoft SQL Server Local DB\Instances\mssqllocaldb"
:setvar DefaultLogPath "C:\Users\VisualAcademy\AppData\Local\Microsoft\Microsoft SQL Server Local DB\Instances\mssqllocaldb"

GO
:on error exit
GO
/*
SQLCMD 모드가 지원되지 않으면 SQLCMD 모드를 검색하고 스크립트를 실행하지 않습니다.
SQLCMD 모드를 설정한 후에 이 스크립트를 다시 사용하려면 다음을 실행합니다.
SET NOEXEC OFF; 
*/
:setvar __IsSqlCmdEnabled "True"
GO
IF N'$(__IsSqlCmdEnabled)' NOT LIKE N'True'
    BEGIN
        PRINT N'이 스크립트를 실행하려면 SQLCMD 모드를 사용하도록 설정해야 합니다.';
        SET NOEXEC ON;
    END


GO
USE [master];


GO

IF (DB_ID(N'$(DatabaseName)') IS NOT NULL) 
BEGIN
    ALTER DATABASE [$(DatabaseName)]
    SET SINGLE_USER WITH ROLLBACK IMMEDIATE;
    DROP DATABASE [$(DatabaseName)];
END

GO
PRINT N'$(DatabaseName)을(를) 만드는 중...'
GO
CREATE DATABASE [$(DatabaseName)]
    ON 
    PRIMARY(NAME = [$(DatabaseName)], FILENAME = N'$(DefaultDataPath)$(DefaultFilePrefix)_Primary.mdf')
    LOG ON (NAME = [$(DatabaseName)_log], FILENAME = N'$(DefaultLogPath)$(DefaultFilePrefix)_Primary.ldf') COLLATE SQL_Latin1_General_CP1_CI_AS
GO
USE [$(DatabaseName)];


GO
IF EXISTS (SELECT 1
           FROM   [master].[dbo].[sysdatabases]
           WHERE  [name] = N'$(DatabaseName)')
    BEGIN
        ALTER DATABASE [$(DatabaseName)]
            SET ANSI_NULLS ON,
                ANSI_PADDING ON,
                ANSI_WARNINGS ON,
                ARITHABORT ON,
                CONCAT_NULL_YIELDS_NULL ON,
                NUMERIC_ROUNDABORT OFF,
                QUOTED_IDENTIFIER ON,
                ANSI_NULL_DEFAULT ON,
                CURSOR_DEFAULT LOCAL,
                CURSOR_CLOSE_ON_COMMIT OFF,
                AUTO_CREATE_STATISTICS ON,
                AUTO_SHRINK OFF,
                AUTO_UPDATE_STATISTICS ON,
                RECURSIVE_TRIGGERS OFF 
            WITH ROLLBACK IMMEDIATE;
        ALTER DATABASE [$(DatabaseName)]
            SET AUTO_CLOSE OFF 
            WITH ROLLBACK IMMEDIATE;
    END


GO
IF EXISTS (SELECT 1
           FROM   [master].[dbo].[sysdatabases]
           WHERE  [name] = N'$(DatabaseName)')
    BEGIN
        ALTER DATABASE [$(DatabaseName)]
            SET ALLOW_SNAPSHOT_ISOLATION OFF;
    END


GO
IF EXISTS (SELECT 1
           FROM   [master].[dbo].[sysdatabases]
           WHERE  [name] = N'$(DatabaseName)')
    BEGIN
        ALTER DATABASE [$(DatabaseName)]
            SET READ_COMMITTED_SNAPSHOT OFF 
            WITH ROLLBACK IMMEDIATE;
    END


GO
IF EXISTS (SELECT 1
           FROM   [master].[dbo].[sysdatabases]
           WHERE  [name] = N'$(DatabaseName)')
    BEGIN
        ALTER DATABASE [$(DatabaseName)]
            SET AUTO_UPDATE_STATISTICS_ASYNC OFF,
                PAGE_VERIFY NONE,
                DATE_CORRELATION_OPTIMIZATION OFF,
                DISABLE_BROKER,
                PARAMETERIZATION SIMPLE,
                SUPPLEMENTAL_LOGGING OFF 
            WITH ROLLBACK IMMEDIATE;
    END


GO
IF IS_SRVROLEMEMBER(N'sysadmin') = 1
    BEGIN
        IF EXISTS (SELECT 1
                   FROM   [master].[dbo].[sysdatabases]
                   WHERE  [name] = N'$(DatabaseName)')
            BEGIN
                EXECUTE sp_executesql N'ALTER DATABASE [$(DatabaseName)]
    SET TRUSTWORTHY OFF,
        DB_CHAINING OFF 
    WITH ROLLBACK IMMEDIATE';
            END
    END
ELSE
    BEGIN
        PRINT N'데이터베이스 설정을 수정할 수 없습니다. 이러한 설정을 적용하려면 SysAdmin이어야 합니다.';
    END


GO
IF IS_SRVROLEMEMBER(N'sysadmin') = 1
    BEGIN
        IF EXISTS (SELECT 1
                   FROM   [master].[dbo].[sysdatabases]
                   WHERE  [name] = N'$(DatabaseName)')
            BEGIN
                EXECUTE sp_executesql N'ALTER DATABASE [$(DatabaseName)]
    SET HONOR_BROKER_PRIORITY OFF 
    WITH ROLLBACK IMMEDIATE';
            END
    END
ELSE
    BEGIN
        PRINT N'데이터베이스 설정을 수정할 수 없습니다. 이러한 설정을 적용하려면 SysAdmin이어야 합니다.';
    END


GO
ALTER DATABASE [$(DatabaseName)]
    SET TARGET_RECOVERY_TIME = 0 SECONDS 
    WITH ROLLBACK IMMEDIATE;


GO
IF EXISTS (SELECT 1
           FROM   [master].[dbo].[sysdatabases]
           WHERE  [name] = N'$(DatabaseName)')
    BEGIN
        ALTER DATABASE [$(DatabaseName)]
            SET FILESTREAM(NON_TRANSACTED_ACCESS = OFF),
                CONTAINMENT = NONE 
            WITH ROLLBACK IMMEDIATE;
    END


GO
IF EXISTS (SELECT 1
           FROM   [master].[dbo].[sysdatabases]
           WHERE  [name] = N'$(DatabaseName)')
    BEGIN
        ALTER DATABASE [$(DatabaseName)]
            SET AUTO_CREATE_STATISTICS ON(INCREMENTAL = OFF),
                MEMORY_OPTIMIZED_ELEVATE_TO_SNAPSHOT = OFF,
                DELAYED_DURABILITY = DISABLED 
            WITH ROLLBACK IMMEDIATE;
    END


GO
IF EXISTS (SELECT 1
           FROM   [master].[dbo].[sysdatabases]
           WHERE  [name] = N'$(DatabaseName)')
    BEGIN
        ALTER DATABASE SCOPED CONFIGURATION SET MAXDOP = 0;
        ALTER DATABASE SCOPED CONFIGURATION FOR SECONDARY SET MAXDOP = PRIMARY;
        ALTER DATABASE SCOPED CONFIGURATION SET LEGACY_CARDINALITY_ESTIMATION = OFF;
        ALTER DATABASE SCOPED CONFIGURATION FOR SECONDARY SET LEGACY_CARDINALITY_ESTIMATION = PRIMARY;
        ALTER DATABASE SCOPED CONFIGURATION SET PARAMETER_SNIFFING = ON;
        ALTER DATABASE SCOPED CONFIGURATION FOR SECONDARY SET PARAMETER_SNIFFING = PRIMARY;
        ALTER DATABASE SCOPED CONFIGURATION SET QUERY_OPTIMIZER_HOTFIXES = OFF;
        ALTER DATABASE SCOPED CONFIGURATION FOR SECONDARY SET QUERY_OPTIMIZER_HOTFIXES = PRIMARY;
    END


GO
IF fulltextserviceproperty(N'IsFulltextInstalled') = 1
    EXECUTE sp_fulltext_database 'enable';


GO
PRINT N'[dbo].[Attendees]을(를) 만드는 중...';


GO
CREATE TABLE [dbo].[Attendees] (
    [Id]           INT           IDENTITY (1, 1) NOT NULL,
    [UID]          INT           NOT NULL,
    [UserID]       NVARCHAR (25) NOT NULL,
    [Name]         NVARCHAR (25) NOT NULL,
    [CreationDate] DATETIME      NULL,
    PRIMARY KEY CLUSTERED ([Id] ASC)
);


GO
PRINT N'[dbo].[Blogs]을(를) 만드는 중...';


GO
CREATE TABLE [dbo].[Blogs] (
    [BlogId]      INT            IDENTITY (1, 1) NOT NULL,
    [Name]        NVARCHAR (50)  NOT NULL,
    [Url]         NVARCHAR (255) NULL,
    [Description] NVARCHAR (MAX) NULL,
    [BloggerName] NVARCHAR (50)  NULL,
    [DateCreated] DATETIME       NULL,
    PRIMARY KEY CLUSTERED ([BlogId] ASC)
);


GO
PRINT N'[dbo].[Boards]을(를) 만드는 중...';


GO
CREATE TABLE [dbo].[Boards] (
    [TID]          INT            IDENTITY (1, 1) NOT NULL,
    [BoardAlias]   NVARCHAR (50)  NULL,
    [Title]        NVARCHAR (50)  NULL,
    [Description]  NVARCHAR (200) NULL,
    [SysopUID]     INT            NULL,
    [IsPublic]     BIT            NULL,
    [GroupName]    NVARCHAR (50)  NULL,
    [GroupOrder]   INT            NULL,
    [MailEnable]   BIT            NULL,
    [ShowList]     BIT            NULL,
    [BoardStyle]   INT            NULL,
    [HeaderHtml]   NVARCHAR (MAX) NULL,
    [FooterHtml]   NVARCHAR (MAX) NULL,
    [MainShowList] INT            NULL,
    PRIMARY KEY CLUSTERED ([TID] ASC)
);


GO
PRINT N'[dbo].[Characters]을(를) 만드는 중...';


GO
CREATE TABLE [dbo].[Characters] (
    [Id]       INT           IDENTITY (1, 1) NOT NULL,
    [Username] NVARCHAR (25) NOT NULL,
    [HeroId]   INT           NOT NULL,
    PRIMARY KEY CLUSTERED ([Id] ASC)
);


GO
PRINT N'[dbo].[Comments]을(를) 만드는 중...';


GO
CREATE TABLE [dbo].[Comments] (
    [Id] INT NOT NULL,
    PRIMARY KEY CLUSTERED ([Id] ASC)
);


GO
PRINT N'[dbo].[CommunityCampJoinMembers]을(를) 만드는 중...';


GO
CREATE TABLE [dbo].[CommunityCampJoinMembers] (
    [Id]            INT            IDENTITY (1, 1) NOT NULL,
    [CommunityName] NVARCHAR (25)  NOT NULL,
    [Name]          NVARCHAR (25)  NOT NULL,
    [Mobile]        NVARCHAR (30)  NOT NULL,
    [Email]         NVARCHAR (100) NOT NULL,
    [Size]          NVARCHAR (10)  NOT NULL,
    [CreationDate]  DATETIME       NULL,
    PRIMARY KEY CLUSTERED ([Id] ASC)
);


GO
PRINT N'[dbo].[Companies]을(를) 만드는 중...';


GO
CREATE TABLE [dbo].[Companies] (
    [Id]   BIGINT         IDENTITY (1, 1) NOT NULL,
    [Name] NVARCHAR (MAX) NULL,
    PRIMARY KEY CLUSTERED ([Id] ASC)
);


GO
PRINT N'[dbo].[Courses]을(를) 만드는 중...';


GO
CREATE TABLE [dbo].[Courses] (
    [CourseId]   INT           IDENTITY (1, 1) NOT NULL,
    [CourseName] NVARCHAR (25) NOT NULL,
    PRIMARY KEY CLUSTERED ([CourseId] ASC)
);


GO
PRINT N'[dbo].[Fives]을(를) 만드는 중...';


GO
CREATE TABLE [dbo].[Fives] (
    [Id]   INT            IDENTITY (1, 1) NOT NULL,
    [Note] NVARCHAR (MAX) NOT NULL,
    PRIMARY KEY CLUSTERED ([Id] ASC)
);


GO
PRINT N'[dbo].[Fours]을(를) 만드는 중...';


GO
CREATE TABLE [dbo].[Fours] (
    [Id]   INT            IDENTITY (1, 1) NOT NULL,
    [Note] NVARCHAR (MAX) NULL,
    PRIMARY KEY CLUSTERED ([Id] ASC)
);


GO
PRINT N'[dbo].[Goods]을(를) 만드는 중...';


GO
CREATE TABLE [dbo].[Goods] (
    [GoodsId]          INT                IDENTITY (1, 1) NOT NULL,
    [GoodsName]        NVARCHAR (100)     NULL,
    [GoodsDescription] NVARCHAR (MAX)     NULL,
    [CreatedDate]      DATETIMEOFFSET (7) NULL,
    PRIMARY KEY CLUSTERED ([GoodsId] ASC)
);


GO
PRINT N'[dbo].[Heroes]을(를) 만드는 중...';


GO
CREATE TABLE [dbo].[Heroes] (
    [Id]      INT                IDENTITY (1, 1) NOT NULL,
    [Name]    NVARCHAR (50)      NOT NULL,
    [Icon]    NVARCHAR (255)     NULL,
    [Created] DATETIMEOFFSET (7) NULL,
    PRIMARY KEY CLUSTERED ([Id] ASC)
);


GO
PRINT N'[dbo].[Ideas]을(를) 만드는 중...';


GO
CREATE TABLE [dbo].[Ideas] (
    [Id]   INT            IDENTITY (1, 1) NOT NULL,
    [Note] NVARCHAR (MAX) NOT NULL,
    PRIMARY KEY CLUSTERED ([Id] ASC)
);


GO
PRINT N'[dbo].[Logs]을(를) 만드는 중...';


GO
CREATE TABLE [dbo].[Logs] (
    [Id]              INT                IDENTITY (1, 1) NOT NULL,
    [Note]            NVARCHAR (MAX)     NULL,
    [Application]     NVARCHAR (50)      NULL,
    [Logger]          NVARCHAR (255)     NULL,
    [LogEvent]        NVARCHAR (MAX)     NULL,
    [Message]         NVARCHAR (MAX)     NULL,
    [MessageTemplate] NVARCHAR (MAX)     NULL,
    [Level]           NVARCHAR (128)     NULL,
    [TimeStamp]       DATETIMEOFFSET (7) NOT NULL,
    [Exception]       NVARCHAR (MAX)     NULL,
    [Properties]      XML                NULL,
    [Callsite]        NVARCHAR (MAX)     NULL,
    [IpAddress]       NVARCHAR (20)      NULL,
    PRIMARY KEY CLUSTERED ([Id] ASC)
);


GO
PRINT N'[dbo].[Maxims]을(를) 만드는 중...';


GO
CREATE TABLE [dbo].[Maxims] (
    [Id]           INT            IDENTITY (1, 1) NOT NULL,
    [Name]         NVARCHAR (25)  NOT NULL,
    [Content]      NVARCHAR (255) NULL,
    [CreationDate] DATETIME       NULL,
    PRIMARY KEY CLUSTERED ([Id] ASC)
);


GO
PRINT N'[dbo].[Memos]을(를) 만드는 중...';


GO
CREATE TABLE [dbo].[Memos] (
    [Num]      INT            IDENTITY (1, 1) NOT NULL,
    [Name]     NVARCHAR (25)  NOT NULL,
    [Email]    NVARCHAR (100) NULL,
    [Title]    NVARCHAR (150) NOT NULL,
    [PostDate] DATETIME       NULL,
    [PostIp]   NVARCHAR (15)  NULL,
    PRIMARY KEY CLUSTERED ([Num] ASC)
);


GO
PRINT N'[dbo].[Menus]을(를) 만드는 중...';


GO
CREATE TABLE [dbo].[Menus] (
    [MenuId]      INT            IDENTITY (1, 1) NOT NULL,
    [MenuOrder]   INT            NOT NULL,
    [ParentId]    INT            NULL,
    [MenuName]    NVARCHAR (100) NOT NULL,
    [MenuPath]    NVARCHAR (255) NULL,
    [IsVisible]   BIT            NOT NULL,
    [CommunityId] INT            NULL,
    [IsBoard]     BIT            NOT NULL,
    [Target]      NVARCHAR (20)  NULL,
    [BoardAlias]  NVARCHAR (50)  NULL,
    PRIMARY KEY CLUSTERED ([MenuId] ASC)
);


GO
PRINT N'[dbo].[NoteComments]을(를) 만드는 중...';


GO
CREATE TABLE [dbo].[NoteComments] (
    [Id]        INT             IDENTITY (1, 1) NOT NULL,
    [BoardName] NVARCHAR (50)   NULL,
    [BoardId]   INT             NOT NULL,
    [Name]      NVARCHAR (25)   NOT NULL,
    [Opinion]   NVARCHAR (4000) NOT NULL,
    [PostDate]  DATETIME        NULL,
    [Password]  NVARCHAR (255)  NOT NULL,
    PRIMARY KEY CLUSTERED ([Id] ASC)
);


GO
PRINT N'[dbo].[Notes]을(를) 만드는 중...';


GO
CREATE TABLE [dbo].[Notes] (
    [Id]           INT            IDENTITY (1, 1) NOT NULL,
    [Name]         NVARCHAR (25)  NOT NULL,
    [Email]        NVARCHAR (100) NULL,
    [Title]        NVARCHAR (150) NOT NULL,
    [PostDate]     DATETIME       NOT NULL,
    [PostIp]       NVARCHAR (15)  NULL,
    [Content]      NTEXT          NOT NULL,
    [Password]     NVARCHAR (255) NULL,
    [ReadCount]    INT            NULL,
    [Encoding]     NVARCHAR (10)  NOT NULL,
    [Homepage]     NVARCHAR (100) NULL,
    [ModifyDate]   DATETIME       NULL,
    [ModifyIp]     NVARCHAR (15)  NULL,
    [FileName]     NVARCHAR (255) NULL,
    [FileSize]     INT            NULL,
    [DownCount]    INT            NULL,
    [Ref]          INT            NOT NULL,
    [Step]         INT            NULL,
    [RefOrder]     INT            NULL,
    [AnswerNum]    INT            NULL,
    [ParentNum]    INT            NULL,
    [CommentCount] INT            NULL,
    [Category]     NVARCHAR (10)  NULL,
    [Num]          INT            NULL,
    [UserId]       INT            NULL,
    [CategoryId]   INT            NULL,
    [BoardId]      INT            NULL,
    [AplicationId] INT            NULL,
    PRIMARY KEY CLUSTERED ([Id] ASC)
);


GO
PRINT N'[dbo].[Ones]을(를) 만드는 중...';


GO
CREATE TABLE [dbo].[Ones] (
    [Id]   INT            IDENTITY (1, 1) NOT NULL,
    [Note] NVARCHAR (MAX) NULL,
    PRIMARY KEY CLUSTERED ([Id] ASC)
);


GO
PRINT N'[dbo].[Permission]을(를) 만드는 중...';


GO
CREATE TABLE [dbo].[Permission] (
    [TID]         INT NOT NULL,
    [UID]         INT NOT NULL,
    [NoAccess]    BIT NULL,
    [List]        BIT NULL,
    [ReadArticle] BIT NULL,
    [Download]    BIT NULL,
    [Write]       BIT NULL,
    [Upload]      BIT NULL,
    [Extra]       BIT NULL,
    [Admin]       BIT NULL,
    [Comment]     BIT NULL,
    PRIMARY KEY CLUSTERED ([TID] ASC, [UID] ASC)
);


GO
PRINT N'[dbo].[PointLogs]을(를) 만드는 중...';


GO
CREATE TABLE [dbo].[PointLogs] (
    [Id]       INT                IDENTITY (1, 1) NOT NULL,
    [UserId]   INT                NOT NULL,
    [Username] NVARCHAR (25)      NULL,
    [NowPoint] INT                NULL,
    [Created]  DATETIMEOFFSET (7) NULL,
    PRIMARY KEY CLUSTERED ([Id] ASC)
);


GO
PRINT N'[dbo].[Points]을(를) 만드는 중...';


GO
CREATE TABLE [dbo].[Points] (
    [Id]         INT           IDENTITY (1, 1) NOT NULL,
    [UserId]     INT           NOT NULL,
    [Username]   NVARCHAR (25) NULL,
    [TotalPoint] INT           NULL,
    PRIMARY KEY CLUSTERED ([Id] ASC)
);


GO
PRINT N'[dbo].[Posts]을(를) 만드는 중...';


GO
CREATE TABLE [dbo].[Posts] (
    [PostId]  INT            IDENTITY (1, 1) NOT NULL,
    [Title]   NVARCHAR (255) NOT NULL,
    [Content] NVARCHAR (MAX) NULL,
    [Created] DATETIME       NULL,
    [BlogId]  INT            NULL,
    PRIMARY KEY CLUSTERED ([PostId] ASC)
);


GO
PRINT N'[dbo].[Questions]을(를) 만드는 중...';


GO
CREATE TABLE [dbo].[Questions] (
    [Id]    INT            IDENTITY (1, 1) NOT NULL,
    [Title] NVARCHAR (MAX) NOT NULL,
    PRIMARY KEY CLUSTERED ([Id] ASC)
);


GO
PRINT N'[dbo].[RecruitRegistrations]을(를) 만드는 중...';


GO
CREATE TABLE [dbo].[RecruitRegistrations] (
    [Id]               INT                IDENTITY (1, 1) NOT NULL,
    [RecruitSettingId] INT                NULL,
    [BoardName]        NVARCHAR (50)      NULL,
    [BoardNum]         INT                NULL,
    [BoardTitle]       NVARCHAR (150)     NULL,
    [CreationDate]     DATETIMEOFFSET (7) NULL,
    [UserId]           INT                NULL,
    [Username]         NVARCHAR (25)      NOT NULL,
    [NickName]         NVARCHAR (100)     NULL,
    PRIMARY KEY CLUSTERED ([Id] ASC)
);


GO
PRINT N'[dbo].[RecruitSettings]을(를) 만드는 중...';


GO
CREATE TABLE [dbo].[RecruitSettings] (
    [Id]           INT                IDENTITY (1, 1) NOT NULL,
    [Remarks]      NVARCHAR (MAX)     NULL,
    [CreationDate] DATETIMEOFFSET (7) NULL,
    [BoardName]    NVARCHAR (50)      NULL,
    [BoardNum]     INT                NOT NULL,
    [BoardTitle]   NVARCHAR (150)     NULL,
    [BoardContent] NVARCHAR (4000)    NULL,
    [StartDate]    SMALLDATETIME      NULL,
    [EventDate]    SMALLDATETIME      NULL,
    [EndDate]      SMALLDATETIME      NULL,
    [MaxCount]     INT                NULL,
    PRIMARY KEY CLUSTERED ([Id] ASC)
);


GO
PRINT N'[dbo].[Signs]을(를) 만드는 중...';


GO
CREATE TABLE [dbo].[Signs] (
    [Id]       INT           IDENTITY (1, 1) NOT NULL,
    [UserId]   NVARCHAR (25) NOT NULL,
    [Password] NVARCHAR (20) NOT NULL,
    PRIMARY KEY CLUSTERED ([Id] ASC)
);


GO
PRINT N'[dbo].[SQLSessions]을(를) 만드는 중...';


GO
CREATE TABLE [dbo].[SQLSessions] (
    [Id]                         NVARCHAR (449)     NOT NULL,
    [Value]                      VARBINARY (MAX)    NOT NULL,
    [ExpiresAtTime]              DATETIMEOFFSET (7) NOT NULL,
    [SlidingExpirationInSeconds] BIGINT             NULL,
    [AbsoluteExpiration]         DATETIMEOFFSET (7) NULL,
    CONSTRAINT [pk_Id] PRIMARY KEY CLUSTERED ([Id] ASC) ON [PRIMARY]
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY];


GO
PRINT N'[dbo].[SQLSessions].[Index_ExpiresAtTime]을(를) 만드는 중...';


GO
CREATE NONCLUSTERED INDEX [Index_ExpiresAtTime]
    ON [dbo].[SQLSessions]([ExpiresAtTime] ASC);


GO
PRINT N'[dbo].[SubTables]을(를) 만드는 중...';


GO
CREATE TABLE [dbo].[SubTables] (
    [Id]      INT            IDENTITY (1, 1) NOT NULL,
    [TableId] INT            NOT NULL,
    [Note]    NVARCHAR (MAX) NULL,
    PRIMARY KEY CLUSTERED ([Id] ASC)
);


GO
PRINT N'[dbo].[Tables]을(를) 만드는 중...';


GO
CREATE TABLE [dbo].[Tables] (
    [Id]        INT            IDENTITY (1, 1) NOT NULL,
    [Note]      NVARCHAR (MAX) NULL,
    [TimeStamp] DATETIME       NULL,
    PRIMARY KEY CLUSTERED ([Id] ASC)
);


GO
PRINT N'[dbo].[Tabs]을(를) 만드는 중...';


GO
CREATE TABLE [dbo].[Tabs] (
    [TabId]       INT            IDENTITY (1, 1) NOT NULL,
    [TabOrder]    INT            NOT NULL,
    [ParentId]    INT            NULL,
    [TabName]     NVARCHAR (100) NOT NULL,
    [TabPath]     NVARCHAR (255) NULL,
    [IsVisible]   BIT            NOT NULL,
    [CommunityId] INT            NULL,
    [IsBoard]     BIT            NOT NULL,
    [Target]      NVARCHAR (20)  NULL,
    [BoardAlias]  NVARCHAR (50)  NULL,
    PRIMARY KEY CLUSTERED ([TabId] ASC)
);


GO
PRINT N'[dbo].[Tasks]을(를) 만드는 중...';


GO
CREATE TABLE [dbo].[Tasks] (
    [Id]           INT            IDENTITY (1, 1) NOT NULL,
    [Title]        NVARCHAR (140) NOT NULL,
    [IsCompleted]  BIT            NULL,
    [CreationDate] DATETIME       NULL,
    PRIMARY KEY CLUSTERED ([Id] ASC)
);


GO
PRINT N'[dbo].[Teches]을(를) 만드는 중...';


GO
CREATE TABLE [dbo].[Teches] (
    [Id]    INT           IDENTITY (1, 1) NOT NULL,
    [Title] NVARCHAR (50) NOT NULL,
    PRIMARY KEY CLUSTERED ([Id] ASC)
);


GO
PRINT N'[dbo].[Threes]을(를) 만드는 중...';


GO
CREATE TABLE [dbo].[Threes] (
    [Id]   INT            IDENTITY (1, 1) NOT NULL,
    [Note] NVARCHAR (MAX) NULL,
    PRIMARY KEY CLUSTERED ([Id] ASC)
);


GO
PRINT N'[dbo].[Twos]을(를) 만드는 중...';


GO
CREATE TABLE [dbo].[Twos] (
    [Id]   INT            IDENTITY (1, 1) NOT NULL,
    [Note] NVARCHAR (MAX) NULL,
    PRIMARY KEY CLUSTERED ([Id] ASC)
);


GO
PRINT N'[dbo].[UserLogs]을(를) 만드는 중...';


GO
CREATE TABLE [dbo].[UserLogs] (
    [Id]                               INT           IDENTITY (1, 1) NOT NULL,
    [Username]                         NVARCHAR (50) NOT NULL,
    [FailedPasswordAttemptCount]       INT           NULL,
    [FailedPasswordAttemptWindowStart] DATETIME      NULL,
    PRIMARY KEY CLUSTERED ([Id] ASC)
);


GO
PRINT N'[dbo].[Users]을(를) 만드는 중...';


GO
CREATE TABLE [dbo].[Users] (
    [UID]      INT            IDENTITY (1, 1) NOT NULL,
    [UserID]   NVARCHAR (25)  NOT NULL,
    [Password] NVARCHAR (255) NOT NULL,
    [Username] NVARCHAR (20)  NULL,
    PRIMARY KEY CLUSTERED ([UID] ASC)
);


GO
PRINT N'[dbo].[Warehouses]을(를) 만드는 중...';


GO
CREATE TABLE [dbo].[Warehouses] (
    [Id]          INT             IDENTITY (1, 1) NOT NULL,
    [Name]        NVARCHAR (200)  NULL,
    [Description] NVARCHAR (1000) NULL,
    [Address]     NVARCHAR (200)  NULL,
    [Phone]       NVARCHAR (20)   NULL,
    [Coordinate]  NVARCHAR (20)   NULL,
    PRIMARY KEY CLUSTERED ([Id] ASC)
);


GO
PRINT N'[dbo].[Attendees]에 대한 명명되지 않은 제약 조건을(를) 만드는 중...';


GO
ALTER TABLE [dbo].[Attendees]
    ADD DEFAULT (GetDate()) FOR [CreationDate];


GO
PRINT N'[dbo].[Blogs]에 대한 명명되지 않은 제약 조건을(를) 만드는 중...';


GO
ALTER TABLE [dbo].[Blogs]
    ADD DEFAULT (GetDate()) FOR [DateCreated];


GO
PRINT N'[dbo].[Boards]에 대한 명명되지 않은 제약 조건을(를) 만드는 중...';


GO
ALTER TABLE [dbo].[Boards]
    ADD DEFAULT ((0)) FOR [SysopUID];


GO
PRINT N'[dbo].[Boards]에 대한 명명되지 않은 제약 조건을(를) 만드는 중...';


GO
ALTER TABLE [dbo].[Boards]
    ADD DEFAULT ((1)) FOR [IsPublic];


GO
PRINT N'[dbo].[Boards]에 대한 명명되지 않은 제약 조건을(를) 만드는 중...';


GO
ALTER TABLE [dbo].[Boards]
    ADD DEFAULT ((0)) FOR [GroupOrder];


GO
PRINT N'[dbo].[Boards]에 대한 명명되지 않은 제약 조건을(를) 만드는 중...';


GO
ALTER TABLE [dbo].[Boards]
    ADD DEFAULT ((0)) FOR [MailEnable];


GO
PRINT N'[dbo].[Boards]에 대한 명명되지 않은 제약 조건을(를) 만드는 중...';


GO
ALTER TABLE [dbo].[Boards]
    ADD DEFAULT ((1)) FOR [ShowList];


GO
PRINT N'[dbo].[Boards]에 대한 명명되지 않은 제약 조건을(를) 만드는 중...';


GO
ALTER TABLE [dbo].[Boards]
    ADD DEFAULT ((0)) FOR [BoardStyle];


GO
PRINT N'[dbo].[Boards]에 대한 명명되지 않은 제약 조건을(를) 만드는 중...';


GO
ALTER TABLE [dbo].[Boards]
    ADD DEFAULT (1) FOR [MainShowList];


GO
PRINT N'[dbo].[CommunityCampJoinMembers]에 대한 명명되지 않은 제약 조건을(를) 만드는 중...';


GO
ALTER TABLE [dbo].[CommunityCampJoinMembers]
    ADD DEFAULT ('L') FOR [Size];


GO
PRINT N'[dbo].[CommunityCampJoinMembers]에 대한 명명되지 않은 제약 조건을(를) 만드는 중...';


GO
ALTER TABLE [dbo].[CommunityCampJoinMembers]
    ADD DEFAULT (GetDate()) FOR [CreationDate];


GO
PRINT N'[dbo].[Goods]에 대한 명명되지 않은 제약 조건을(를) 만드는 중...';


GO
ALTER TABLE [dbo].[Goods]
    ADD DEFAULT (GetDate()) FOR [CreatedDate];


GO
PRINT N'[dbo].[Heroes]에 대한 명명되지 않은 제약 조건을(를) 만드는 중...';


GO
ALTER TABLE [dbo].[Heroes]
    ADD DEFAULT (GetDate()) FOR [Created];


GO
PRINT N'[dbo].[Maxims]에 대한 명명되지 않은 제약 조건을(를) 만드는 중...';


GO
ALTER TABLE [dbo].[Maxims]
    ADD DEFAULT (GetDate()) FOR [CreationDate];


GO
PRINT N'[dbo].[Memos]에 대한 명명되지 않은 제약 조건을(를) 만드는 중...';


GO
ALTER TABLE [dbo].[Memos]
    ADD DEFAULT (getdate()) FOR [PostDate];


GO
PRINT N'[dbo].[Menus]에 대한 명명되지 않은 제약 조건을(를) 만드는 중...';


GO
ALTER TABLE [dbo].[Menus]
    ADD DEFAULT (0) FOR [ParentId];


GO
PRINT N'[dbo].[Menus]에 대한 명명되지 않은 제약 조건을(를) 만드는 중...';


GO
ALTER TABLE [dbo].[Menus]
    ADD DEFAULT (1) FOR [IsVisible];


GO
PRINT N'[dbo].[Menus]에 대한 명명되지 않은 제약 조건을(를) 만드는 중...';


GO
ALTER TABLE [dbo].[Menus]
    ADD DEFAULT (1) FOR [CommunityId];


GO
PRINT N'[dbo].[Menus]에 대한 명명되지 않은 제약 조건을(를) 만드는 중...';


GO
ALTER TABLE [dbo].[Menus]
    ADD DEFAULT (1) FOR [IsBoard];


GO
PRINT N'[dbo].[Menus]에 대한 명명되지 않은 제약 조건을(를) 만드는 중...';


GO
ALTER TABLE [dbo].[Menus]
    ADD DEFAULT ('_self') FOR [Target];


GO
PRINT N'[dbo].[NoteComments]에 대한 명명되지 않은 제약 조건을(를) 만드는 중...';


GO
ALTER TABLE [dbo].[NoteComments]
    ADD DEFAULT (GetDate()) FOR [PostDate];


GO
PRINT N'[dbo].[Notes]에 대한 명명되지 않은 제약 조건을(를) 만드는 중...';


GO
ALTER TABLE [dbo].[Notes]
    ADD DEFAULT GetDate() FOR [PostDate];


GO
PRINT N'[dbo].[Notes]에 대한 명명되지 않은 제약 조건을(를) 만드는 중...';


GO
ALTER TABLE [dbo].[Notes]
    ADD DEFAULT 0 FOR [ReadCount];


GO
PRINT N'[dbo].[Notes]에 대한 명명되지 않은 제약 조건을(를) 만드는 중...';


GO
ALTER TABLE [dbo].[Notes]
    ADD DEFAULT 0 FOR [FileSize];


GO
PRINT N'[dbo].[Notes]에 대한 명명되지 않은 제약 조건을(를) 만드는 중...';


GO
ALTER TABLE [dbo].[Notes]
    ADD DEFAULT 0 FOR [DownCount];


GO
PRINT N'[dbo].[Notes]에 대한 명명되지 않은 제약 조건을(를) 만드는 중...';


GO
ALTER TABLE [dbo].[Notes]
    ADD DEFAULT 0 FOR [Step];


GO
PRINT N'[dbo].[Notes]에 대한 명명되지 않은 제약 조건을(를) 만드는 중...';


GO
ALTER TABLE [dbo].[Notes]
    ADD DEFAULT 0 FOR [RefOrder];


GO
PRINT N'[dbo].[Notes]에 대한 명명되지 않은 제약 조건을(를) 만드는 중...';


GO
ALTER TABLE [dbo].[Notes]
    ADD DEFAULT 0 FOR [AnswerNum];


GO
PRINT N'[dbo].[Notes]에 대한 명명되지 않은 제약 조건을(를) 만드는 중...';


GO
ALTER TABLE [dbo].[Notes]
    ADD DEFAULT 0 FOR [ParentNum];


GO
PRINT N'[dbo].[Notes]에 대한 명명되지 않은 제약 조건을(를) 만드는 중...';


GO
ALTER TABLE [dbo].[Notes]
    ADD DEFAULT 0 FOR [CommentCount];


GO
PRINT N'[dbo].[Notes]에 대한 명명되지 않은 제약 조건을(를) 만드는 중...';


GO
ALTER TABLE [dbo].[Notes]
    ADD DEFAULT ('Free') FOR [Category];


GO
PRINT N'[dbo].[Notes]에 대한 명명되지 않은 제약 조건을(를) 만드는 중...';


GO
ALTER TABLE [dbo].[Notes]
    ADD DEFAULT 0 FOR [CategoryId];


GO
PRINT N'[dbo].[Notes]에 대한 명명되지 않은 제약 조건을(를) 만드는 중...';


GO
ALTER TABLE [dbo].[Notes]
    ADD DEFAULT 0 FOR [BoardId];


GO
PRINT N'[dbo].[Notes]에 대한 명명되지 않은 제약 조건을(를) 만드는 중...';


GO
ALTER TABLE [dbo].[Notes]
    ADD DEFAULT 0 FOR [AplicationId];


GO
PRINT N'[dbo].[Permission]에 대한 명명되지 않은 제약 조건을(를) 만드는 중...';


GO
ALTER TABLE [dbo].[Permission]
    ADD DEFAULT (0) FOR [NoAccess];


GO
PRINT N'[dbo].[Permission]에 대한 명명되지 않은 제약 조건을(를) 만드는 중...';


GO
ALTER TABLE [dbo].[Permission]
    ADD DEFAULT (1) FOR [List];


GO
PRINT N'[dbo].[Permission]에 대한 명명되지 않은 제약 조건을(를) 만드는 중...';


GO
ALTER TABLE [dbo].[Permission]
    ADD DEFAULT (1) FOR [ReadArticle];


GO
PRINT N'[dbo].[Permission]에 대한 명명되지 않은 제약 조건을(를) 만드는 중...';


GO
ALTER TABLE [dbo].[Permission]
    ADD DEFAULT (1) FOR [Download];


GO
PRINT N'[dbo].[Permission]에 대한 명명되지 않은 제약 조건을(를) 만드는 중...';


GO
ALTER TABLE [dbo].[Permission]
    ADD DEFAULT (1) FOR [Write];


GO
PRINT N'[dbo].[Permission]에 대한 명명되지 않은 제약 조건을(를) 만드는 중...';


GO
ALTER TABLE [dbo].[Permission]
    ADD DEFAULT (1) FOR [Upload];


GO
PRINT N'[dbo].[Permission]에 대한 명명되지 않은 제약 조건을(를) 만드는 중...';


GO
ALTER TABLE [dbo].[Permission]
    ADD DEFAULT (0) FOR [Extra];


GO
PRINT N'[dbo].[Permission]에 대한 명명되지 않은 제약 조건을(를) 만드는 중...';


GO
ALTER TABLE [dbo].[Permission]
    ADD DEFAULT (0) FOR [Admin];


GO
PRINT N'[dbo].[Permission]에 대한 명명되지 않은 제약 조건을(를) 만드는 중...';


GO
ALTER TABLE [dbo].[Permission]
    ADD DEFAULT (1) FOR [Comment];


GO
PRINT N'[dbo].[PointLogs]에 대한 명명되지 않은 제약 조건을(를) 만드는 중...';


GO
ALTER TABLE [dbo].[PointLogs]
    ADD DEFAULT (1) FOR [NowPoint];


GO
PRINT N'[dbo].[PointLogs]에 대한 명명되지 않은 제약 조건을(를) 만드는 중...';


GO
ALTER TABLE [dbo].[PointLogs]
    ADD DEFAULT (GetDate()) FOR [Created];


GO
PRINT N'[dbo].[Points]에 대한 명명되지 않은 제약 조건을(를) 만드는 중...';


GO
ALTER TABLE [dbo].[Points]
    ADD DEFAULT (0) FOR [TotalPoint];


GO
PRINT N'[dbo].[Posts]에 대한 명명되지 않은 제약 조건을(를) 만드는 중...';


GO
ALTER TABLE [dbo].[Posts]
    ADD DEFAULT GetDate() FOR [Created];


GO
PRINT N'[dbo].[Posts]에 대한 명명되지 않은 제약 조건을(를) 만드는 중...';


GO
ALTER TABLE [dbo].[Posts]
    ADD DEFAULT (0) FOR [BlogId];


GO
PRINT N'[dbo].[RecruitRegistrations]에 대한 명명되지 않은 제약 조건을(를) 만드는 중...';


GO
ALTER TABLE [dbo].[RecruitRegistrations]
    ADD DEFAULT (GetDate()) FOR [CreationDate];


GO
PRINT N'[dbo].[RecruitSettings]에 대한 명명되지 않은 제약 조건을(를) 만드는 중...';


GO
ALTER TABLE [dbo].[RecruitSettings]
    ADD DEFAULT (GetDate()) FOR [CreationDate];


GO
PRINT N'[dbo].[RecruitSettings]에 대한 명명되지 않은 제약 조건을(를) 만드는 중...';


GO
ALTER TABLE [dbo].[RecruitSettings]
    ADD DEFAULT (1000) FOR [MaxCount];


GO
PRINT N'[dbo].[Tables]에 대한 명명되지 않은 제약 조건을(를) 만드는 중...';


GO
ALTER TABLE [dbo].[Tables]
    ADD DEFAULT (GetDate()) FOR [TimeStamp];


GO
PRINT N'[dbo].[Tabs]에 대한 명명되지 않은 제약 조건을(를) 만드는 중...';


GO
ALTER TABLE [dbo].[Tabs]
    ADD DEFAULT (0) FOR [ParentId];


GO
PRINT N'[dbo].[Tabs]에 대한 명명되지 않은 제약 조건을(를) 만드는 중...';


GO
ALTER TABLE [dbo].[Tabs]
    ADD DEFAULT (1) FOR [IsVisible];


GO
PRINT N'[dbo].[Tabs]에 대한 명명되지 않은 제약 조건을(를) 만드는 중...';


GO
ALTER TABLE [dbo].[Tabs]
    ADD DEFAULT (0) FOR [CommunityId];


GO
PRINT N'[dbo].[Tabs]에 대한 명명되지 않은 제약 조건을(를) 만드는 중...';


GO
ALTER TABLE [dbo].[Tabs]
    ADD DEFAULT (1) FOR [IsBoard];


GO
PRINT N'[dbo].[Tabs]에 대한 명명되지 않은 제약 조건을(를) 만드는 중...';


GO
ALTER TABLE [dbo].[Tabs]
    ADD DEFAULT ('_self') FOR [Target];


GO
PRINT N'[dbo].[Tasks]에 대한 명명되지 않은 제약 조건을(를) 만드는 중...';


GO
ALTER TABLE [dbo].[Tasks]
    ADD DEFAULT (GetDate()) FOR [CreationDate];


GO
PRINT N'[dbo].[UserLogs]에 대한 명명되지 않은 제약 조건을(를) 만드는 중...';


GO
ALTER TABLE [dbo].[UserLogs]
    ADD DEFAULT (0) FOR [FailedPasswordAttemptCount];


GO
PRINT N'[dbo].[UserLogs]에 대한 명명되지 않은 제약 조건을(를) 만드는 중...';


GO
ALTER TABLE [dbo].[UserLogs]
    ADD DEFAULT (GetDate()) FOR [FailedPasswordAttemptWindowStart];


GO
PRINT N'[dbo].[BlogPosts]을(를) 만드는 중...';


GO
CREATE VIEW [dbo].[BlogPosts]
AS 
    Select 
        b.Name, b.BloggerName, 
        p.Title, p.Content, p.Created
    From  
        Posts p Join Blogs b 
            On p.BlogId = b.BlogId
GO
PRINT N'[dbo].[BoardViews]을(를) 만드는 중...';


GO
CREATE VIEW [dbo].[BoardViews]
AS 
	SELECT 
		[TID] As BoardId, 
		[BoardAlias], 
		[Title], 
		[Description], 
		[SysopUID] As SysopUsername, 
		[IsPublic], 
		[GroupName], 
		[GroupOrder], 
		[MailEnable], 
		[ShowList], 
		[BoardStyle], 
		[HeaderHtml], 
		[FooterHtml], 
		[MainShowList] 
	FROM [Boards]
GO
PRINT N'[dbo].[AddPermission]을(를) 만드는 중...';


GO
--[!] 권한 입력 저장 프로시저
Create Proc dbo.AddPermission
    @TID Int, 
    @UID Int, 
    @NoAccess Bit, 
    @List Bit, 
    @ReadArticle Bit, 
    @Download Bit, 
    @Write Bit, 
    @Upload Bit, 
    @Extra Bit, 
    @Admin Bit,
    @Comment Bit
As
    Insert Into Permission (
		TID, UID, NoAccess, List, ReadArticle, Download, Write, Upload, Extra, Admin, Comment
	) 
    Values (
		@TID, @UID, @NoAccess, @List, @ReadArticle, @Download, @Write, @Upload, @Extra, @Admin, @Comment
	)
GO
PRINT N'[dbo].[DeleteMemo]을(를) 만드는 중...';


GO

--[e] 메모 데이터 삭제용 저장 프로시저
Create Proc dbo.DeleteMemo
(
	@Num Int
)
As
	Delete Memos
	Where Num = @Num
GO
PRINT N'[dbo].[DeleteNote]을(를) 만드는 중...';


GO
--[7] 해당 글을 지우는 저장 프로시저(답변글이 있으면 업데이트하고 없으면 지운다.): DeleteNote, NotesDelete
Create Proc dbo.DeleteNote
    @Id Int,
    @Password NVarChar(255) -- 암호 매개변수 추가
As
    Declare @cnt Int
    Select @cnt = Count(*) From Notes
    Where Id = @Id And Password = @Password

    If @cnt = 0
    Begin
        Return 0 -- 번호와 암호가 맞는게 없으면 0을 반환
    End	

    Declare @AnswerNum Int
    Declare @RefOrder Int
    Declare @Ref Int
    Declare @ParentNum Int

    Select
        @AnswerNum = AnswerNum,     @RefOrder = RefOrder,
        @Ref = Ref,                 @ParentNum = ParentNum
    From Notes
    Where Id = @Id

    If @AnswerNum = 0
    Begin
        If @RefOrder > 0 
        Begin
            UPDATE Notes SET RefOrder = RefOrder - 1
            WHERE Ref = @Ref AND RefOrder > @RefOrder
            UPDATE Notes SET AnswerNum = AnswerNum - 1 WHERE Id = @ParentNum
        End
        Delete Notes Where Id = @Id
        Delete Notes 
        WHERE 
            Id = @ParentNum AND ModifyIp = N'((DELETED))' AND AnswerNum = 0	
    End
    Else
    Begin
        Update Notes 
        Set 
            Name = N'(Unknown)', Email = '', Password = '',
            Title = N'(삭제된 글입니다.)', 
            Content = N'(삭제된 글입니다. ' 
            + N'현재 답변이 포함되어 있기 때문에 내용만 삭제되었습니다.)',
            ModifyIp = N'((DELETED))', FileName = '', 
            FileSize = 0, CommentCount = 0
        Where Id = @Id  
    End
GO
PRINT N'[dbo].[DeleteSigns]을(를) 만드는 중...';


GO
--ModifySigns 'master', '1234', 2


--[5] 삭제 저장 프로시저
Create Proc dbo.DeleteSigns
	@Id Int
As
	Delete Signs Where Id = @Id
GO
PRINT N'[dbo].[DeleteUsers]을(를) 만드는 중...';


GO
--ModifyUsers 'master', '1234', 2


--[5] 삭제 저장 프로시저
Create Proc dbo.DeleteUsers
	@UID Int
As
	Delete Users Where UID = @UID
GO
PRINT N'[dbo].[GetBlogPost]을(를) 만드는 중...';


GO
CREATE PROCEDURE [dbo].[GetBlogPost]
AS
	Begin Transaction -- 의미 없지만, 학습상...
		Select 
			b.Name, b.BloggerName, 
			p.Title, p.Content, p.Created
		From  
			Posts p Join Blogs b 
				On p.BlogId = b.BlogId 
		Order By p.PostId Desc
		
		If @@ERROR > 0 
			RollBack Transaction 
	Commit Transaction
GO
PRINT N'[dbo].[GetCountNotes]을(를) 만드는 중...';


GO
--[5] DotNetNote 테이블에 있는 레코드의 개수를 구하는 저장 프로시저: GetCountNotes, NotesCount
Create Proc dbo.GetCountNotes
As
    Select Count(*) From Notes
GO
PRINT N'[dbo].[GetLogsWithPaging]을(를) 만드는 중...';


GO
CREATE PROCEDURE [dbo].[GetLogsWithPaging]
	@PageIndex int = 0,		-- @PageIndex : 페이지 인덱스 : 0, 1, 2, ...
	@PageSize int = 10		-- @PageSize : 한 페이지에 표시할 레코드 수
AS
	Select 
		[RowNumbers], 
		[Id], 
		[Note], 
		[Application], 
		[Logger], 
		[LogEvent], 
		[Message], 
		[MessageTemplate], 
		[Level], 
		[TimeStamp], 
		[Exception], 
		[Properties], 
		[Callsite], 
		[IpAddress]
	From 
		(
			Select 
				ROW_NUMBER() Over (Order By Id Desc) As RowNumbers, 
				[Id], 
				[Note], 
				[Application], 
				[Logger], 
				[LogEvent], 
				[Message], 
				[MessageTemplate], 
				[Level], 
				[TimeStamp], 
				[Exception], 
				[Properties], 
				[Callsite], 
				[IpAddress] 
			From Logs 
		)
		As TempRowTables
	Where 
		RowNumbers 
			Between 
				(@PageIndex * @PageSize + 1) 
			And 
				(@PageIndex + 1) * @PageSize
GO
PRINT N'[dbo].[GetTableById]을(를) 만드는 중...';


GO
CREATE PROCEDURE [dbo].[GetTableById]
	@Id int
AS
	Select [Id], [Note] From Tables Where Id = @Id
GO
PRINT N'[dbo].[GetTables]을(를) 만드는 중...';


GO
CREATE PROCEDURE [dbo].[GetTables]
AS
	Select [Id], [Note] From Tables
GO
PRINT N'[dbo].[GetTablesNoteByIdWithOutput]을(를) 만드는 중...';


GO
CREATE PROCEDURE [dbo].[GetTablesNoteByIdWithOutput]
	@Id int = 0,
	@Note NVarChar(Max) Output
AS
	Select @Note = Note From Tables Where Id = @Id
GO
PRINT N'[dbo].[GetTablesWithPaging]을(를) 만드는 중...';


GO
CREATE PROCEDURE [dbo].[GetTablesWithPaging]
	@PageIndex int = 0,		-- @PageIndex : 페이지 인덱스 : 0, 1, 2, ...
	@PageSize int = 10		-- @PageSize : 한 페이지에 표시할 레코드 수
AS
	Select Id, Note 
	From 
		(
			Select 
				ROW_NUMBER() Over (Order By Id Desc) As RowNumbers, Id, Note 
			From Tables
		)
		As TempRowTables
	Where 
		RowNumbers 
			Between 
				(@PageIndex * @PageSize + 1) 
			And 
				(@PageIndex + 1) * @PageSize
GO
PRINT N'[dbo].[GetUsers]을(를) 만드는 중...';


GO
CREATE PROCEDURE [dbo].[GetUsers]
	@UID int = 0
AS
	Select [UID], [UserID], [Password], [Username] 
	From Users 
	Where UID = @UID
GO
PRINT N'[dbo].[ListMemo]을(를) 만드는 중...';


GO

--[b] 메모 출력용 저장 프로시저
Create Proc dbo.ListMemo
As
	Select Num, Name, Email, Title, PostDate, PostIp
	From Memos Order By Num Desc
GO
PRINT N'[dbo].[ListNotes]을(를) 만드는 중...';


GO
--[2] 게시판(DotNetNote)에서 데이터 출력: ListNotes
Create Procedure dbo.ListNotes
    @Page Int
As
    With DotNetNoteOrderedLists 
    As 
    (
        Select 
            [Id], [Name], [Email], [Title], [PostDate], [ReadCount], 
            [Ref], [Step], [RefOrder], [AnswerNum], [ParentNum], 
            [CommentCount], [FileName], [FileSize], [DownCount], 
            ROW_NUMBER() Over (Order By Ref Desc, RefOrder Asc) 
            As 'RowNumber' 
        From Notes
    ) 
    Select * From DotNetNoteOrderedLists 
    Where RowNumber Between @Page * 10 + 1 And (@Page + 1) * 10
GO
PRINT N'[dbo].[ListSigns]을(를) 만드는 중...';


GO
--WriteSigns 'redplus', '1234'


--[2] 출력 저장 프로시저
--Create Proc dbo.ListSigns
--As
--	Select * From Signs Order By Id Desc
--Go
Create Proc dbo.ListSigns
As
	Select [Id], [UserId], [Password] From Signs Order By Id Desc
GO
PRINT N'[dbo].[ListUsers]을(를) 만드는 중...';


GO
--WriteUsers 'redplus', '1234'


--[2] 출력 저장 프로시저
--Create Proc dbo.ListUsers
--As
--	Select * From Users Order By UID Desc
--Go
Create Proc dbo.ListUsers
As
	Select [UID], [UserID], [Password] From Users Order By UID Desc
GO
PRINT N'[dbo].[ModifyMemo]을(를) 만드는 중...';


GO

--[d] 메모 데이터 수정용 저장 프로시저
Create Proc dbo.ModifyMemo
(
	@Name NVarChar(25),
	@Email NVarChar(100),
	@Title NVarChar(150),
	@Num Int 
)
As
Begin Transaction
	Update Memos 
	Set 
		Name = @Name, 
		Email = @Email,
		Title = @Title
	Where Num = @Num
Commit Transaction
GO
PRINT N'[dbo].[ModifyNote]을(를) 만드는 중...';


GO
--[8] 해당 글을 수정하는 저장 프로시저: ModifyNote, NotesModify
Create Proc dbo.ModifyNote
    @Name       NVarChar(25), 
    @Email      NVarChar(100), 
    @Title      NVarChar(150), 
    @ModifyIp   NVarChar(15), 
    @Content    NText,
    @Password   NVarChar(255), 
    @Encoding   NVarChar(10), 
    @Homepage   NVarChar(100),
    @FileName	NVarChar(255),
    @FileSize	Int,

	@Category	NVarChar(50), -- 추가 
    
    @Id Int
As
    Declare @cnt Int

    Select @cnt = Count(*) From Notes 
    Where Id = @Id And Password = @Password

    If @cnt > 0 -- 번호와 암호가 맞는게 있다면...
    Begin
        Update Notes 
        Set 
            Name = @Name, Email = @Email, Title = @Title,
            ModifyIp = @ModifyIp, ModifyDate = GetDate(),
            Content = @Content, Encoding = @Encoding,
            Homepage = @Homepage, FileName = @FileName, FileSize = @FileSize
        Where Id = @Id

        Select '1'
    End
    Else
        Select '0'
GO
PRINT N'[dbo].[ModifySigns]을(를) 만드는 중...';


GO
--ViewSigns 5


--[4] 수정 저장 프로시저
Create Proc dbo.ModifySigns
	@UserId NVarChar(25),
	@Password NVarChar(20),
	@Id Int
As
	Begin Tran
		Update Signs
		Set	
			UserId = @UserId,
			[Password] = @Password
		Where Id = @Id
	Commit Tran
GO
PRINT N'[dbo].[ModifyUsers]을(를) 만드는 중...';


GO
--ViewUsers 5


--[4] 수정 저장 프로시저
Create Proc dbo.ModifyUsers
	@UserID NVarChar(25),
	@Password NVarChar(255),
	@UID Int
As
	Begin Tran
		Update Users
		Set	
			UserID = @UserID,
			[Password] = @Password
		Where UID = @UID
	Commit Tran
GO
PRINT N'[dbo].[ReplyNote]을(를) 만드는 중...';


GO
--[4] 게시판(DotNetNote)에 글을 답변: ReplyNote, NotesReply
Create Proc dbo.ReplyNote
    @Name       NVarChar(25), 
    @PostIp     NVarChar(15), 
    @Title      NVarChar(150), 
    @Content    NText, 
    @Category   NVarChar(10) = '', 

    @Email      NVarChar(100), 
    @Password   NVarChar(255), 
    @Encoding   NVarChar(10), 
    @Homepage   NVarChar(100),
    @ParentNum  Int,                    -- 부모글의 고유번호(Id)
    @FileName   NVarChar(255),
    @FileSize   Int
As
    --[0] 변수 선언
    Declare @MaxRefOrder Int
    Declare @MaxRefAnswerNum Int
    Declare @ParentRef Int
    Declare @ParentStep Int
    Declare @ParentRefOrder Int

    --[1] 부모글의 답변수(AnswerNum)를 1증가
    Update Notes Set AnswerNum = AnswerNum + 1 Where Id = @ParentNum 

    --[2] 같은 글에 대해서 답변을 두 번 이상하면 먼저 답변한 게 위에 나타나게 한다.
    Select @MaxRefOrder = RefOrder, @MaxRefAnswerNum = AnswerNum From Notes 
    Where 
        ParentNum = @ParentNum And 
        RefOrder = 
            (Select Max(RefOrder) From Notes Where ParentNum = @ParentNum)

    If @MaxRefOrder Is Null
    Begin
        Select @MaxRefOrder = RefOrder From Notes Where Id = @ParentNum
        Set @MaxRefAnswerNum = 0  
    End 

    --[3] 중간에 답변달 때(비집고 들어갈 자리 마련)
    Select 
        @ParentRef = Ref, @ParentStep = Step 
    From Notes Where Id = @ParentNum

    Update Notes 
    Set 
        RefOrder = RefOrder + 1 
    Where 
        Ref = @ParentRef And RefOrder > (@MaxRefOrder + @MaxRefAnswerNum)

    --[4] 최종저장
    Insert Notes
    (
        Name, Email, Title, PostIp, Content, Password, Encoding, 
        Homepage, Ref, Step, RefOrder, ParentNum, FileName, FileSize,
        Category
    )
    Values
    (
        @Name, @Email, @Title, @PostIp, @Content, @Password, @Encoding, 
        @Homepage, @ParentRef, @ParentStep + 1, 
        @MaxRefOrder + @MaxRefAnswerNum + 1, @ParentNum, @FileName, @FileSize,
        @Category
    )
GO
PRINT N'[dbo].[SearchMemo]을(를) 만드는 중...';


GO

--[f] 메모 데이터 검색용 저장 프로시저(동적SQL 사용)
Create Proc dbo.SearchMemo
(
	@SearchField NVarChar(10),
	@SearchQuery NVarChar(50)
)
-- With Encryption -- 현재 SP문 암호화
As
	Declare @strSql NVarChar(250) -- 변수 선언
	Set @strSql = 
		'
		Select Num, Name, Email, Title, PostDate, PostIp 
		From Memos
		Where ' + @SearchField + ' Like 
			N''%' + @SearchQuery + '%''
		Order By Num Desc
		'
	--Print @strSql
	Exec (@strSql) --완성된 SQL문 실행
GO
PRINT N'[dbo].[SearchNoteCount]을(를) 만드는 중...';


GO
--[6] 검색 결과의 레코드 수 반환: SearchNoteCount, NotesSearchCount 
Create Proc dbo.SearchNoteCount
    @SearchField NVarChar(25),
    @SearchQuery NVarChar(25)
As
    Set @SearchQuery = '%' + @SearchQuery + '%'

    Select Count(*)
    From Notes
    Where
    (
        Case @SearchField 
            When 'Name' Then [Name]
            When 'Title' Then Title
            When 'Content' Then Content
            Else @SearchQuery
        End
    ) 
    Like 
    @SearchQuery
GO
PRINT N'[dbo].[SearchNotes]을(를) 만드는 중...';


GO
--[9] 게시판(DotNetNote)에서 데이터 검색 리스트: SearchNotes, NotesSearchList 
Create Procedure dbo.SearchNotes
    @Page Int,
    @SearchField NVarChar(25),
    @SearchQuery NVarChar(25)
As
    With DotNetNoteOrderedLists 
    As 
    (
        Select 
            [Id], [Name], [Email], [Title], [PostDate], 
            [ReadCount], [Ref], [Step], [RefOrder], [AnswerNum], 
            [ParentNum], [CommentCount], [FileName], [FileSize], 
            [DownCount], 
            ROW_NUMBER() Over (Order By Ref Desc, RefOrder Asc) 
            As 'RowNumber' 
        From Notes
        Where ( 
            Case @SearchField 
                When 'Name' Then [Name] 
                When 'Title' Then Title 
                When 'Content' Then Content 
                Else 
                @SearchQuery 
            End 
        ) Like '%' + @SearchQuery + '%'
    ) 
    Select 
        [Id], [Name], [Email], [Title], [PostDate], 
        [ReadCount], [Ref], [Step], [RefOrder], 
        [AnswerNum], [ParentNum], [CommentCount], 
        [FileName], [FileSize], [DownCount], 
        [RowNumber] 
    From DotNetNoteOrderedLists 
    Where RowNumber Between @Page * 10 + 1 And (@Page + 1) * 10  
    Order By Id Desc
GO
PRINT N'[dbo].[SearchSigns]을(를) 만드는 중...';


GO
--DeleteSigns 2


--[6] 검색 저장 프로시저
Create Proc dbo.SearchSigns
	@SearchField NVarChar(25),
	@SearchQuery NVarChar(25)
As
	Declare @strSql NVarChar(255)
	Set @strSql = '
		Select * From Signs 
		Where 
			' + @SearchField + ' Like ''%' + @SearchQuery + '%''
	'
	-- Print @strSql
	Exec(@strSql)
GO
PRINT N'[dbo].[SearchUsers]을(를) 만드는 중...';


GO
--DeleteUsers 2


--[6] 검색 저장 프로시저
Create Proc dbo.SearchUsers
	@SearchField NVarChar(25),
	@SearchQuery NVarChar(25)
As
	Declare @strSql NVarChar(255)
	Set @strSql = '
		Select * From Users 
		Where 
			' + @SearchField + ' Like ''%' + @SearchQuery + '%''
	'
	-- Print @strSql
	Exec(@strSql)
GO
PRINT N'[dbo].[ViewMemo]을(를) 만드는 중...';


GO

--[c] 메모 상세 보기용 저장 프로시저
Create Proc dbo.ViewMemo
(
	@Num Int
)
As
	Select Num, Name, Email, Title, PostDate, PostIp 
	From Memos 
	Where Num = @Num
GO
PRINT N'[dbo].[ViewNote]을(를) 만드는 중...';


GO
--[3] 해당 글을 세부적으로 읽어오는 저장 프로시저: ViewNote, NotesView
Create Procedure dbo.ViewNote
    @Id Int
As
    -- 조회수 카운트 1증가
    Update Notes Set ReadCount = ReadCount + 1 Where Id = @Id
    
    -- 모든 항목 조회
    Select * From Notes Where Id = @Id
GO
PRINT N'[dbo].[ViewSigns]을(를) 만드는 중...';


GO
--ListSigns


--[3] 상세 저장 프로시저
Create Proc dbo.ViewSigns
	@Id Int
As
	Select [Id], [UserId], [Password] From Signs Where Id = @Id
GO
PRINT N'[dbo].[ViewUsers]을(를) 만드는 중...';


GO
--ListUsers


--[3] 상세 저장 프로시저
Create Proc dbo.ViewUsers
	@UID Int
As
	Select [UID], [UserID], [Password] From Users Where UID = @UID
GO
PRINT N'[dbo].[WriteMemo]을(를) 만드는 중...';


GO
--[3] SQL 저장 프로시저 6가지 작성

--[a] 메모 입력용 저장 프로시저
Create Procedure dbo.WriteMemo
(
	@Name NVarChar(25),
	@Email NVarChar(100),
	@Title NVarChar(150),
	@PostIp NVarChar(15)
)
As
	Insert Memos(Name, Email, Title, PostIp)
	Values(@Name, @Email, @Title, @PostIp)
GO
PRINT N'[dbo].[WriteNote]을(를) 만드는 중...';


GO
--[1] 게시판(DotNetNote)에 글을 작성 : WriteNote
Create Proc dbo.WriteNote
    -- 5W1H
    @Name       NVarChar(25), 
    @PostIp     NVarChar(15), 
    @Title      NVarChar(150), 
    @Content    NText, 
	@Category   NVarChar(10), 

    @Email      NVarChar(100), 
    @Password   NVarChar(255), 
    @Encoding   NVarChar(10), 
    @Homepage   NVarChar(100),
    @FileName   NVarChar(255),
    @FileSize   Int
As
    Declare @MaxRef Int
    Select @MaxRef = Max(IsNull(Ref, 0)) From Notes
 
    If @MaxRef Is Null Or @MaxRef = 0
        Set @MaxRef = 1 -- 테이블 생성 후 처음만 비교
    Else
        Set @MaxRef = @MaxRef + 1

    Insert Notes
    (
        Name, Email, Title, PostIp, Content, Password, Encoding, 
        Homepage, Ref, FileName, FileSize,
		Category 
    )
    Values
    (
        @Name, @Email, @Title, @PostIp, @Content, @Password, @Encoding, 
        @Homepage, @MaxRef, @FileName, @FileSize,
		@Category
    )
GO
PRINT N'[dbo].[WriteSigns]을(를) 만드는 중...';


GO
--[Sign][0][2] Signs 관련 저장 프로시저 생성

--[1] 입력 저장 프로시저
Create Proc dbo.WriteSigns
	@UserId NVarChar(25),
	@Password NVarChar(20)
As
	Insert Into Signs Values(@UserId, @Password)
GO
PRINT N'[dbo].[WriteUsers]을(를) 만드는 중...';


GO
--[User][0][2] Users 관련 저장 프로시저 생성

--[1] 입력 저장 프로시저
Create Proc dbo.WriteUsers
	@UserID NVarChar(25),
	@Password NVarChar(255)
As
	Insert Into Users (UserID, Password) Values(@UserID, @Password)
GO
DECLARE @VarDecimalSupported AS BIT;

SELECT @VarDecimalSupported = 0;

IF ((ServerProperty(N'EngineEdition') = 3)
    AND (((@@microsoftversion / power(2, 24) = 9)
          AND (@@microsoftversion & 0xffff >= 3024))
         OR ((@@microsoftversion / power(2, 24) = 10)
             AND (@@microsoftversion & 0xffff >= 1600))))
    SELECT @VarDecimalSupported = 1;

IF (@VarDecimalSupported > 0)
    BEGIN
        EXECUTE sp_db_vardecimal_storage_format N'$(DatabaseName)', 'ON';
    END


GO
PRINT N'업데이트가 완료되었습니다.';


GO
