"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require("@angular/core");
var http_1 = require("@angular/http");
var Observable_1 = require("rxjs/Observable");
require("rxjs/add/observable/throw");
require("rxjs/add/operator/map");
require("rxjs/add/operator/catch"); // 에러 잡기 
var TestDataService = (function () {
    function TestDataService(http) {
        this.http = http;
        this.API_URI = "/api/OneService";
    }
    TestDataService.prototype.getOnes = function () {
        return this.http.get(this.API_URI).map(function (response) {
            var ones = response.json();
            // 중간 업데이트 코드 가능
            return ones;
        }).catch(this.handleError);
    };
    TestDataService.prototype.getOne = function (id) {
        return this.http.get(this.API_URI + "/" + id).map(function (res) { return res.json(); }).catch(this.handleError);
    };
    // 에러 처리 공통 메서드 
    TestDataService.prototype.handleError = function (error) {
        console.error("서버측 에러 발생: ", error);
        if (error instanceof http_1.Response) {
            var errMessage = "";
            try {
                errMessage = error.json().error;
            }
            catch (err) {
                errMessage = error.statusText;
            }
            return Observable_1.Observable.throw(errMessage);
        }
        return Observable_1.Observable.throw(error || "서버 에러...");
    };
    // 데이터 저장 
    TestDataService.prototype.postOne = function (one) {
        return this.http.post(this.API_URI, one).map(function (response) {
            var data = response.json();
            return data;
        }).catch(function (err) { return Observable_1.Observable.throw(err); });
    };
    return TestDataService;
}());
TestDataService = __decorate([
    core_1.Injectable(),
    __metadata("design:paramtypes", [http_1.Http])
], TestDataService);
exports.TestDataService = TestDataService;
//# sourceMappingURL=TestDataService.js.map