"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
/// <summary>
/// 데이터서비스는 HTTP와 관련된 기능만 담당, 재사용 가능 
/// </summary>
var core_1 = require("@angular/core");
// app.module.ts에 HttpModule 등록
var http_1 = require("@angular/http");
var Observable_1 = require("rxjs/Observable");
require("rxjs/add/operator/map");
require("rxjs/add/operator/catch");
require("rxjs/add/observable/throw");
require("rxjs/add/operator/do"); // 추가 
require("rxjs/add/operator/delay"); // 추가
var FiveDataService = (function () {
    // DI
    function FiveDataService(http) {
        this.http = http;
        // Web API 경로
        this.API_URI = "/api/FiveService";
    }
    // GET: GetAll() 
    FiveDataService.prototype.getFives = function () {
        return this.http.get(this.API_URI) // .delay(1000) // 1초 딜레이 추가
            .map(function (response) {
            var fives = response.json(); // <> 구문으로 캐스팅 표현
            return fives;
        })
            .catch(this.handleError);
    };
    // GetAllWithPaging: 페이징 처리
    FiveDataService.prototype.getFivesWithPaging = function (newPage, pageSize) {
        return this.http.get(this.API_URI + "/page/" + newPage + "/" + pageSize)
            .map(function (response) {
            var totalRecordCount = +response.headers.get("X-TotalRecordCount");
            var fives = response.json();
            return {
                totalRecordCount: totalRecordCount,
                records: fives
            };
        })
            .catch(this.handleError);
    };
    // POST: Add() 
    FiveDataService.prototype.addFive = function (four) {
        return this.http.post(this.API_URI, four)
            .map(function (response) {
            var r = response.json(); // as 구문으로 캐스팅 표현
            console.log("입력 처리 완료: " + response.status); // [추가] => 201 반환 확인 
            return r;
        })
            .catch(this.handleError);
    };
    // PUT: Update()
    FiveDataService.prototype.updateFive = function (id, five) {
        return this.http.put(this.API_URI + "/" + id, five)
            .map(function (response) {
            //const r = response.json() as IFive;
            //console.log("데이터 수정 완료");
            //return r;
            return five; // No Content
        })
            .catch(this.handleError);
    };
    // GET: GetById()
    FiveDataService.prototype.getFive = function (id) {
        return this.http.get(this.API_URI + "/" + id)
            .map(function (response) {
            var Fours = response.json(); // <IFour[]>
            return Fours;
        })
            .catch(this.handleError);
    };
    // DELETE
    FiveDataService.prototype.deleteFive = function (id) {
        return this.http.delete(this.API_URI + "/" + id)
            .map(function (response) {
            return true;
        })
            .catch(this.handleError);
    };
    // 예외 처리 출력 공통 메서드
    FiveDataService.prototype.handleError = function (error) {
        console.log('서버 에러 발생:', error);
        if (error instanceof http_1.Response) {
            return Observable_1.Observable.throw(error);
        }
        return Observable_1.Observable.throw(error || 'Web API에서 에러 발생');
    };
    return FiveDataService;
}());
FiveDataService = __decorate([
    core_1.Injectable(),
    __metadata("design:paramtypes", [http_1.Http])
], FiveDataService);
exports.FiveDataService = FiveDataService;
//# sourceMappingURL=dataservice.js.map