"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require("@angular/core");
var dataservice_1 = require("./dataservice");
var FiveListComponent = (function () {
    //[1] 생성자
    function FiveListComponent(ds) {
        this.ds = ds;
        this.models = [];
        this.pageSize = 10; // 추가 
    }
    //[2] 컴포넌트(페이지) 로드
    FiveListComponent.prototype.ngOnInit = function () {
        //this.getFives();
        this.getFivesWithPage(1);
    };
    // GET
    FiveListComponent.prototype.getFives = function () {
        var _this = this;
        this.ds.getFives().subscribe(function (models) { _this.models = models; }, // 성공 콜백
        function (error) { _this.errorMsg = error; }, // 에러 콜백
        function () { return console.log('getFives 메서드 호출...'); } // 마무리
        );
    };
    // GET
    FiveListComponent.prototype.getFivesWithPage = function (newPage) {
        var _this = this;
        this.ds.getFivesWithPaging(newPage, this.pageSize).subscribe(function (response) {
            _this.models = response.records; // 현재 페이지의 레코드 리스트 
            _this.totalRecordCount = response.totalRecordCount; // 총 레코드 건수
        }, // 성공 콜백
        function (error) { _this.errorMsg = error; }, // 에러 콜백
        function () { return console.log('getFives 메서드 호출...'); } // 마무리(추가)
        );
    };
    FiveListComponent.prototype.pageIndexChanging = function (newPageIndex) {
        this.getFivesWithPage(newPageIndex);
    };
    return FiveListComponent;
}());
FiveListComponent = __decorate([
    core_1.Component({
        selector: 'five-list',
        template: require('./list.component.html')
    }),
    __metadata("design:paramtypes", [dataservice_1.FiveDataService])
], FiveListComponent);
exports.FiveListComponent = FiveListComponent;
//# sourceMappingURL=list.component.js.map