/// <summary>
/// 데이터서비스는 HTTP와 관련된 기능만 담당, 재사용 가능 
/// </summary>
"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require("@angular/core");
// app.module.ts에 HttpModule 등록
var http_1 = require("@angular/http");
var Observable_1 = require("rxjs/Observable");
require("rxjs/add/operator/map");
require("rxjs/add/operator/catch");
require("rxjs/add/observable/throw");
require("rxjs/add/operator/do"); // 추가 
require("rxjs/add/operator/delay"); // 추가
var FourDataService = (function () {
    // DI
    function FourDataService(http) {
        this.http = http;
        // Web API 경로
        this.API_URI = "/api/FourService";
    }
    // GET: GetAll() 
    FourDataService.prototype.getFours = function () {
        return this.http.get(this.API_URI).delay(1000) // 1초 딜레이 추가
            .map(function (response) {
            var fours = response.json(); // <IFour[]> 형으로 변환
            return fours;
        })
            .catch(function (err) { return Observable_1.Observable.throw(err); }); // TODO: this.handleError
    };
    // TODO: 페이징 처리 미리 테스트
    FourDataService.prototype.getFoursWithPaging = function (newPage) {
        return this.http.get("/api/FiveService/page/" + newPage + "/5")
            .map(function (response) {
            var totalRecordCount = response.headers.get("X-TotalRecordCount");
            var fours = response.json(); // <IFour[]> 형으로 변환
            return fours;
        })
            .catch(function (err) { return Observable_1.Observable.throw(err); }); // TODO: this.handleError
    };
    // POST: Add() 
    FourDataService.prototype.addFour = function (four) {
        return this.http.post(this.API_URI, four)
            .map(function (response) {
            var r = response.json(); // as 구문으로 표현
            console.log("입력 처리 완료: " + response.status); // [추가] => 201 반환 확인 
            return r;
        })
            .catch(this.handleError);
    };
    // PUT: Update()
    FourDataService.prototype.updateFour = function (id, four) {
        return this.http.put(this.API_URI + "/" + id, four)
            .map(function (response) {
            var r = response.json();
            console.log("데이터 수정 완료");
            return r;
        })
            .catch(this.handleError);
    };
    // GET: GetById()
    FourDataService.prototype.getFour = function (id) {
        return this.http.get(this.API_URI + "/" + id)
            .map(function (response) {
            var Fours = response.json(); // <IFour[]>
            return Fours;
        })
            .catch(this.handleError);
    };
    // DELETE
    FourDataService.prototype.deleteFour = function (id) {
        return this.http.delete(this.API_URI + "/" + id)
            .map(function (response) {
            return true;
        })
            .catch(this.handleError);
    };
    // 예외 처리 출력 공통 메서드
    FourDataService.prototype.handleError = function (error) {
        console.log('서버 에러 발생:', error);
        if (error instanceof http_1.Response) {
            return Observable_1.Observable.throw(error);
        }
        return Observable_1.Observable.throw(error || 'Web API에서 에러 발생');
    };
    return FourDataService;
}());
FourDataService = __decorate([
    core_1.Injectable(),
    __metadata("design:paramtypes", [http_1.Http])
], FourDataService);
exports.FourDataService = FourDataService;
//# sourceMappingURL=four.dataservice.js.map