"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var dataservice_1 = require("./dataservice");
var QuestionEditComponent = (function () {
    function QuestionEditComponent(route, ds, router) {
        this.route = route;
        this.ds = ds;
        this.router = router;
        this.model = { id: 0, title: '' }; //[!] 기본값으로 초기화
    }
    QuestionEditComponent.prototype.ngOnInit = function () {
        var id = +this.route.snapshot.params["id"]; // id 매개변수 받기
        this.id = id;
        this.getData(id);
    };
    QuestionEditComponent.prototype.goList = function () {
        this.router.navigate(['/question']);
    };
    // 데이터 상세 보기 
    QuestionEditComponent.prototype.getData = function (id) {
        var _this = this;
        this.ds.getById(id).subscribe(function (model) {
            var tmpModel = JSON.stringify(model);
            _this.model = JSON.parse(tmpModel);
        }, function (error) { return console.log(error); });
    };
    QuestionEditComponent.prototype.btnEdit_Click = function (frmValue) {
        var _this = this;
        this.ds.update(this.id, frmValue)
            .subscribe(function (model) {
            if (model) {
                console.log("수정 완료..." + JSON.stringify(model));
            }
            else {
                console.log("수정되지 않음...");
            }
        }, function (err) { return console.log(err); }, // 에러 핸들러
        function () { _this.goDetail(); } // 마무리 핸들러 
        );
    };
    // 상세보기 페이지로 이동
    QuestionEditComponent.prototype.goDetail = function () {
        this.router.navigate(['/questiondetail', this.id]);
    };
    return QuestionEditComponent;
}());
QuestionEditComponent = __decorate([
    core_1.Component({
        selector: 'question-edit',
        template: require('./edit.component.html')
    }),
    __metadata("design:paramtypes", [router_1.ActivatedRoute,
        dataservice_1.QuestionDataService, router_1.Router])
], QuestionEditComponent);
exports.QuestionEditComponent = QuestionEditComponent;
//# sourceMappingURL=edit.component.js.map