"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var dataservice_1 = require("./dataservice");
var forms_1 = require("@angular/forms"); // 
var QuestionEditReactiveComponent = (function () {
    function QuestionEditReactiveComponent(route, ds, router, fb) {
        this.route = route;
        this.ds = ds;
        this.router = router;
        this.fb = fb;
        this.model = { id: 0, title: '' }; //[!] 기본값으로 초기화
    }
    QuestionEditReactiveComponent.prototype.ngOnInit = function () {
        var id = +this.route.snapshot.params["id"]; // id 매개변수 받기
        this.id = id;
        this.getData(id);
        //[!]
        this.formCreate(); //[1] 페이지 로드시 FormGroup 생성 
    };
    //[!] FormGroup 생성 및 다시 값 설정
    QuestionEditReactiveComponent.prototype.formCreate = function () {
        this.editForm = this.fb.group({
            id: [this.model.id, forms_1.Validators.required],
            title: [this.model.title, [forms_1.Validators.required, forms_1.Validators.minLength(2)]]
        });
        //console.log("값" + this.editForm.get("title").value); 
    };
    QuestionEditReactiveComponent.prototype.goList = function () {
        this.router.navigate(['/question']);
    };
    // 데이터 상세 보기 
    QuestionEditReactiveComponent.prototype.getData = function (id) {
        var _this = this;
        this.ds.getById(id).subscribe(function (model) {
            var tmpFour = JSON.stringify(model);
            _this.model = JSON.parse(tmpFour);
            //[2] 특정 id에 해당하는 자료 가지고 온 후 그 값으로 다시 설정
            _this.formCreate();
        }, function (error) { return console.log(error); });
    };
    //[!]
    QuestionEditReactiveComponent.prototype.save = function (event) {
        var _this = this;
        console.log(event);
        console.log(this.editForm.value); // id와 title을 갖는 값
        // 폼의 값을 전송할 때에는 UI 또는 코드에서 직접 전송 가능
        this.ds.update(this.id, this.editForm.value)
            .subscribe(function (model) {
            if (model) {
                console.log("수정 완료..." + JSON.stringify(model));
            }
            else {
                console.log("수정되지 않음...");
            }
        }, function (err) { return console.log(err); }, // 에러 핸들러
        function () { _this.goDetail(); } // 마무리 핸들러 
        );
    };
    // 상세보기 페이지로 이동
    QuestionEditReactiveComponent.prototype.goDetail = function () {
        this.router.navigate(['/questiondetail', this.id]);
    };
    return QuestionEditReactiveComponent;
}());
QuestionEditReactiveComponent = __decorate([
    core_1.Component({
        selector: 'question-edit-reactive',
        template: require('./edit.reactive.component.html')
    }),
    __metadata("design:paramtypes", [router_1.ActivatedRoute,
        dataservice_1.QuestionDataService, router_1.Router,
        forms_1.FormBuilder])
], QuestionEditReactiveComponent);
exports.QuestionEditReactiveComponent = QuestionEditReactiveComponent;
//# sourceMappingURL=edit.reactive.component.js.map