"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require("@angular/core");
var dataservice_1 = require("./dataservice");
var QuestionListComponent = (function () {
    //[1] 생성자
    function QuestionListComponent(ds) {
        this.ds = ds;
        this.models = [];
        this.pageSize = 5; // 추가 
    }
    //[2] 컴포넌트(페이지) 로드
    QuestionListComponent.prototype.ngOnInit = function () {
        this.getAllWithPage(1); // 처음 로드할 때 기본으로 1페이지를 보여줌
    };
    // GET
    QuestionListComponent.prototype.getAll = function () {
        var _this = this;
        this.ds.getAll().subscribe(function (models) { _this.models = models; }, // 성공 콜백
        function (error) { _this.errorMsg = error; }, // 에러 콜백
        function () { return console.log('getFives 메서드 호출...'); } // 마무리
        );
    };
    // GET
    QuestionListComponent.prototype.getAllWithPage = function (newPage) {
        var _this = this;
        this.ds.getAllWithPaging(newPage, this.pageSize).subscribe(function (response) {
            _this.models = response.records; // 현재 페이지의 레코드 리스트 
            _this.totalRecordCount = response.totalRecordCount; // 총 레코드 건수
        }, // 성공 콜백
        function (error) { _this.errorMsg = error; }, // 에러 콜백
        function () { return console.log('getFives 메서드 호출...'); } // 마무리(추가)
        );
    };
    // 페이저에서 넘어온 번호에 해당하는 페이지를 다시 호출 
    QuestionListComponent.prototype.pageIndexChanging = function (newPageIndex) {
        this.getAllWithPage(newPageIndex);
    };
    return QuestionListComponent;
}());
QuestionListComponent = __decorate([
    core_1.Component({
        selector: "question-list",
        template: require('./list.component.html')
    }),
    __metadata("design:paramtypes", [dataservice_1.QuestionDataService])
], QuestionListComponent);
exports.QuestionListComponent = QuestionListComponent;
//# sourceMappingURL=list.component.js.map