"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require("@angular/core");
var AnPagingHelperComponent = (function () {
    function AnPagingHelperComponent() {
        this.pages = [];
        this.isVisible = false;
        this.previousEnabled = false;
        this.nextEnabled = true;
        /// <summary>
        /// 현재 보여줄 페이지 인덱스: 0, 1, 2 : PageIndex | PageNumber
        /// </summary>
        this.currentPage = 1;
        this.pageIndexChanging = new core_1.EventEmitter();
    }
    Object.defineProperty(AnPagingHelperComponent.prototype, "pageSize", {
        get: function () {
            return this._pageSize;
        },
        set: function (size) {
            this._pageSize = size;
            this.update();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AnPagingHelperComponent.prototype, "recordCount", {
        get: function () {
            return this._recordCount;
        },
        set: function (itemCount) {
            this._recordCount = itemCount;
            this.update();
        },
        enumerable: true,
        configurable: true
    });
    AnPagingHelperComponent.prototype.ngOnInit = function () {
    };
    AnPagingHelperComponent.prototype.update = function () {
        if (this._recordCount && this._pageSize) {
            this.totalPages = Math.ceil(this._recordCount / this.pageSize);
            this.isVisible = true;
            if (this.recordCount >= this.pageSize) {
                for (var i = 1; i < this.totalPages + 1; i++) {
                    this.pages.push(i);
                }
            }
            return;
        }
        this.isVisible = false;
    };
    AnPagingHelperComponent.prototype.previousNext = function (direction, event) {
        var page = this.currentPage;
        if (direction == -1) {
            if (page > 1)
                page--;
        }
        else {
            if (page < this.totalPages)
                page++;
        }
        this.btnChangePage(page, event);
    };
    AnPagingHelperComponent.prototype.btnChangePage = function (page, event) {
        if (event) {
            event.preventDefault();
        }
        if (this.currentPage === page)
            return;
        this.currentPage = page;
        this.previousEnabled = this.currentPage > 1;
        this.nextEnabled = this.currentPage < this.totalPages;
        this.pageIndexChanging.emit(page);
    };
    return AnPagingHelperComponent;
}());
__decorate([
    core_1.Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], AnPagingHelperComponent.prototype, "pageSize", null);
__decorate([
    core_1.Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], AnPagingHelperComponent.prototype, "recordCount", null);
__decorate([
    core_1.Output(),
    __metadata("design:type", core_1.EventEmitter)
], AnPagingHelperComponent.prototype, "pageIndexChanging", void 0);
AnPagingHelperComponent = __decorate([
    core_1.Component({
        selector: 'an-paging-helper',
        template: "\n        <div [hidden]=\"!isVisible\">\n          <ul class=\"pagination pagination-sm\">\n            <li [class.disabled]=\"!previousEnabled\" (click)=\"previousNext(-1, $event)\">\n              <a aria-label=\"Previous\">\n                <span aria-hidden=\"true\">&laquo;</span>\n              </a>\n            </li>\n            <li *ngFor=\"let page of pages\" (click)=\"btnChangePage(page, $event)\" [class.active]=\"currentPage === page\">\n              <a>{{ page }}</a>\n            </li>\n            <li [class.disabled]=\"!nextEnabled\" (click)=\"previousNext(1, $event)\">\n              <a aria-label=\"Next\">\n                <span aria-hidden=\"true\">&raquo;</span>\n              </a>\n            </li>\n          </ul>\n        </div>\n    ",
        styles: [""]
    }),
    __metadata("design:paramtypes", [])
], AnPagingHelperComponent);
exports.AnPagingHelperComponent = AnPagingHelperComponent;
//# sourceMappingURL=AnPagingHelperComponent.js.map