"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require("@angular/core");
//[1] 심플 버전
//import { Http } from '@angular/http';
//[2] RxJs 버전
var http_1 = require("@angular/http");
require("rxjs/add/operator/map");
require("rxjs/add/operator/catch");
var Observable_1 = require("rxjs/Observable");
require("rxjs/add/observable/throw");
var WebCampComponent = (function () {
    // 생성자에 Http 주입
    function WebCampComponent(_http) {
        //[1] 심플 버전
        //_http.get(this.API_URI).subscribe(result => {
        //    this.speakers = result.json();
        //});
        this._http = _http;
        this.API_URI = "http://www.dotnetnote.com/api/WebCampService";
        this.title = "발표자 리스트";
        //[2] RxJs 버전
        this.getSpeakers();
    }
    WebCampComponent.prototype.getSpeakers = function () {
        var _this = this;
        return this._http.get(this.API_URI)
            .map(function (response) { return response.json(); })
            .catch(this.handleError)
            .subscribe(function (speakers) { return _this.speakers = speakers; }, function (error) { return _this.errorMessage = error; });
    };
    WebCampComponent.prototype.handleError = function (error) {
        console.error(error);
        return Observable_1.Observable.throw(error.json().error || 'Server error');
    };
    return WebCampComponent;
}());
WebCampComponent = __decorate([
    core_1.Component({
        selector: 'webcamp',
        template: require('./webcamp.component.html')
    }),
    __metadata("design:paramtypes", [http_1.Http])
], WebCampComponent);
exports.WebCampComponent = WebCampComponent;
//# sourceMappingURL=webcamp.component.js.map